<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Lookup Methods</TITLE>
<link href="suif1_48.html" rel=Next>
<link href="suif1_46.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_46.html">previous</A>, <A HREF="suif1_48.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC47" HREF="suif1_toc.html#TOC47">Lookup Methods</A></H2>
<P>
<A NAME="IDX292"></A>

</P>
<P>
SUIF symbol tables provide a number of methods to search for and
retrieve particular types, symbols, and variable definitions.  Most of
these lookup methods will optionally search all the ancestor symbol
tables, making it easy to determine if an object is defined in the
current scope.

</P>
<P>
<A NAME="IDX293"></A>
The <CODE>lookup_type</CODE> method is available at all levels in the symbol
table hierarchy to search for SUIF types.  Given an existing type, the
method searches for a type that is the same.  It uses the <CODE>is_same</CODE>
method from the <CODE>type_node</CODE> class to perform these comparisons.  If
a matching type is not found within the current symbol table,
<CODE>lookup_type</CODE> will continue searching in the ancestor symbol tables
by default.  However, if the optional <CODE>up</CODE> parameter is set to
<CODE>FALSE</CODE>, it will give up after searching the first table.

</P>
<P>
<A NAME="IDX294"></A>
<A NAME="IDX295"></A>
<A NAME="IDX296"></A>
<A NAME="IDX297"></A>
Several methods are provided to lookup symbols.  Each different kind of
symbol (variable, procedure, and label) has its own name space, so the
<CODE>lookup_sym</CODE> method requires that you specify both the name and the
kind of symbol for which to search.  This method may be used with all
symbol tables.  For convenience, other methods are defined as wrappers
around <CODE>lookup_sym</CODE>.  Each of these wrappers searches for a
particular kind of symbol: <CODE>lookup_var</CODE> searches for variables,
<CODE>lookup_proc</CODE> searches for procedures, and <CODE>lookup_label</CODE>
searches for labels.  Because procedure symbols may only be defined in
global symbol tables, the <CODE>lookup_proc</CODE> method is declared in the
<CODE>global_symtab</CODE> class.  Similarly, the <CODE>lookup_label</CODE> method
is declared in the <CODE>block_symtab</CODE> class, because labels may only be
defined within procedures.  By default, all of these methods search the
current symbol table and, if unsuccessful, proceed to search the
ancestor symbol tables.  The optional <CODE>up</CODE> parameters may be set to
<CODE>FALSE</CODE> to turn off this default behavior and only search the
current symbol table.

</P>
<P>
<A NAME="IDX298"></A>
A symbol for a global variable is just a declaration of that variable
and does not automatically have any storage allocated.  Variable
definitions are required to allocate storage and to specify alignment
requirements and any initial data for the variable.  Since the variable
definitions are not directly connected to the variable symbols, the
<CODE>lookup_var_def</CODE> method is provided to search a symbol table for
the definition of a particular variable symbol.  This method does not
search the parent symbol table.  In general the <CODE>definition</CODE> method
in the <CODE>var_sym</CODE> class is a better way to locate a variable
definition.

</P>
<P>
<A NAME="IDX299"></A>
<A NAME="IDX300"></A>
Symbols and types are assigned ID numbers (see section <A HREF="suif1_50.html#SEC50">Numbering Types and Symbols</A>) that uniquely identify them within a particular context.  The
<CODE>lookup_type_id</CODE> method searches the types defined within a symbol
table and its ancestors for a type with the specified ID number.  The
<CODE>lookup_sym_id</CODE> does the same thing for symbols.

</P>
<P>
<A NAME="IDX301"></A>
Besides searching for one of the entries in a symbol table, you can also
search for one of its children in the symbol table hierarchy.  The
<CODE>lookup_child</CODE> method searches through the list of children for a
symbol table with a given name.  This may not be very useful, but it is
included for completeness.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_46.html">previous</A>, <A HREF="suif1_48.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
